Eu tenho este roteiro:
#!/usr/bin/env sh
# note: we must use sh instead of bash, it's more cross-platform
set -e;
if [[ "$skip_postinstall" == "yes" ]]; then # TODO rename 'skip_postinstall' to something more specific
echo "skipping postinstall routine.";
exit 0;
fi
export FORCE_COLOR=1;
export skip_postinstall="yes"; # TODO rename 'skip_postinstall' to something more specific
mkdir -p "$HOME/.oresoftware/bin" || {
echo "Could not create .oresoftware dir in user home.";
exit 1;
}
(
echo 'Installing run-tsc-if on your system.';
curl -H 'Cache-Control: no-cache' -s -S -o- 'https://raw.githubusercontent.com/oresoftware/run-tsc-if/master/install.sh' | bash || {
echo 'Could not install run-tsc-if on your system. That is a problem.';
exit 1;
}
) 2> /dev/null
if [[ "$(uname -s)" != "Darwin" ]]; then
exit 0;
fi
if [[ ! -f "$HOME/.oresoftware/bin/realpath" ]]; then
(
curl --silent -o- 'https://raw.githubusercontent.com/oresoftware/realpath/master/assets/install.sh' | bash || {
echo "Could not install realpath on your system.";
exit 1;
}
)
fi
# the end of the postinstall script
quando eu executo, recebo:
./assets/postinstall.sh: 7: ./assets/postinstall.sh: [[: not found
Installing run-tsc-if on your system.
=> Installing 'run-tsc-if' on your system.
=> run-tsc-if download/installation succeeded.
./assets/postinstall.sh: 29: ./assets/postinstall.sh: [[: not found
./assets/postinstall.sh: 33: ./assets/postinstall.sh: [[: not found
mas se eu substituir os colchetes duplos [[ por colchetes simples, recebo:
./postinstall.sh: 7: [: unexpected operator
que vem apenas de:
if [ "$skip_postinstall" == "yes" ]; then
echo "skipping postinstall routine.";
exit 0;
fi
hum o que eu faço? Eu tentei usar test
em vez de [
e [[
e isso também não funcionou.
[[
é o "teste estendido" originário do ksh e também suportado pelo bash/zsh, portanto, não deve reconhecê-los. Além disso, o==
operador não é POSIX,=
é o operador de teste do shell para comparação de strings.Estes são dois bashisms muito comuns .
Eu acho que é porque sh não pode lidar com == comparação, então precisa ser:
isso não
maluco